// Copyright (c) 2006-2008 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// WARNING: DO NOT USE standard header file protection.
// This file may be include several times in its entirety.

// This file contains a list of all messages supported by Windows as would be
// handled in a message loop.  We only list the messages provided in
// <winuser.h>, and do not currently include (the otherwise undefined)
// #define WM_SYSTIMER 0x118

// By using various macro tricks, this list can be used to create pretty print
// functions for the messages.  See message_loop.cc for an example.

// Start list of Windows Messages given in <winuser.h>
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NULL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CREATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DESTROY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SIZE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ACTIVATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETFOCUS)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_KILLFOCUS)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ENABLE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETREDRAW)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETTEXT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETTEXT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETTEXTLENGTH)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PAINT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CLOSE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUERYENDSESSION)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUERYOPEN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ENDSESSION)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUIT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ERASEBKGND)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYSCOLORCHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SHOWWINDOW)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_WININICHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETTINGCHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DEVMODECHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ACTIVATEAPP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_FONTCHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_TIMECHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CANCELMODE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETCURSOR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSEACTIVATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CHILDACTIVATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUEUESYNC)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETMINMAXINFO)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PAINTICON)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ICONERASEBKGND)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NEXTDLGCTL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SPOOLERSTATUS)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DRAWITEM)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MEASUREITEM)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DELETEITEM)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_VKEYTOITEM)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CHARTOITEM)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETFONT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETFONT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETHOTKEY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETHOTKEY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUERYDRAGICON)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_COMPAREITEM)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETOBJECT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_COMPACTING)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_COMMNOTIFY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_WINDOWPOSCHANGING)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_WINDOWPOSCHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_POWER)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_COPYDATA)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CANCELJOURNAL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NOTIFY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INPUTLANGCHANGEREQUEST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INPUTLANGCHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_TCARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_HELP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_USERCHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NOTIFYFORMAT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CONTEXTMENU)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_STYLECHANGING)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_STYLECHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DISPLAYCHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETICON)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SETICON)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCCREATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCDESTROY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCCALCSIZE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCHITTEST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCPAINT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCACTIVATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETDLGCODE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYNCPAINT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCMOUSEMOVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCLBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCLBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCLBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCRBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCRBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCRBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCMBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCMBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCMBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCXBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCXBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCXBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INPUT_DEVICE_CHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INPUT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_KEYFIRST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_KEYDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_KEYUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DEADCHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYSKEYDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYSKEYUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYSCHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYSDEADCHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_UNICHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_KEYLAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_KEYLAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_STARTCOMPOSITION)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_ENDCOMPOSITION)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_COMPOSITION)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_KEYLAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INITDIALOG)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_COMMAND)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SYSCOMMAND)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_TIMER)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_HSCROLL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_VSCROLL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INITMENU)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_INITMENUPOPUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MENUSELECT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MENUCHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ENTERIDLE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MENURBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MENUDRAG)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MENUGETOBJECT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_UNINITMENUPOPUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MENUCOMMAND)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CHANGEUISTATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_UPDATEUISTATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUERYUISTATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLORMSGBOX)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLOREDIT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLORLISTBOX)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLORBTN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLORDLG)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLORSCROLLBAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CTLCOLORSTATIC)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSEFIRST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSEMOVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_LBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_LBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_LBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_RBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_RBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_RBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSEWHEEL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_XBUTTONDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_XBUTTONUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_XBUTTONDBLCLK)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSEHWHEEL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSELAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSELAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSELAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSELAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PARENTNOTIFY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ENTERMENULOOP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_EXITMENULOOP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NEXTMENU)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SIZING)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CAPTURECHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOVING)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_POWERBROADCAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DEVICECHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDICREATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIDESTROY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIACTIVATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIRESTORE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDINEXT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIMAXIMIZE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDITILE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDICASCADE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIICONARRANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIGETACTIVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDISETMENU)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ENTERSIZEMOVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_EXITSIZEMOVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DROPFILES)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MDIREFRESHMENU)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_SETCONTEXT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_NOTIFY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_CONTROL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_COMPOSITIONFULL)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_SELECT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_CHAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_REQUEST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_KEYDOWN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_IME_KEYUP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSEHOVER)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_MOUSELEAVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCMOUSEHOVER)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_NCMOUSELEAVE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_WTSSESSION_CHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_TABLET_FIRST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_TABLET_LAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CUT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_COPY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PASTE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CLEAR)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_UNDO)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_RENDERFORMAT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_RENDERALLFORMATS)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DESTROYCLIPBOARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DRAWCLIPBOARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PAINTCLIPBOARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_VSCROLLCLIPBOARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_SIZECLIPBOARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_ASKCBFORMATNAME)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CHANGECBCHAIN)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_HSCROLLCLIPBOARD)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_QUERYNEWPALETTE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PALETTEISCHANGING)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PALETTECHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_HOTKEY)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PRINT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PRINTCLIENT)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_APPCOMMAND)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_THEMECHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_CLIPBOARDUPDATE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DWMCOMPOSITIONCHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DWMNCRENDERINGCHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DWMCOLORIZATIONCOLORCHANGED)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_DWMWINDOWMAXIMIZEDCHANGE)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_GETTITLEBARINFOEX)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_HANDHELDFIRST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_HANDHELDLAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_AFXFIRST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_AFXLAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PENWINFIRST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_PENWINLAST)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_APP)
A_NAMED_MESSAGE_FROM_WINUSER_H(WM_USER)
// End list of Windows Messages given in <winuser.h>
